---
title: Symbol.search
slug: Web/JavaScript/Reference/Global_Objects/Symbol/search
tags:
  - ECMAScript 2015
  - JavaScript
  - Property
  - Symbol
---
<div>{{JSRef}}</div>

<p>The <strong><code>Symbol.search</code></strong> well-known symbol specifies the method that returns the index within a string that matches the regular expression. This function is called by the {{jsxref("String.prototype.search()")}} method.</p>

<p>For more information, see {{jsxref("RegExp.@@search", "RegExp.prototype[@@search]()")}} and {{jsxref("String.prototype.search()")}}.</p>

<div>{{EmbedInteractiveExample("pages/js/symbol-search.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<div>{{js_property_attributes(0,0,0)}}</div>

<h2 id="Examples">Examples</h2>

<h3 id="Custom_string_search">Custom string search</h3>

<pre class="brush: js notranslate">class caseInsensitiveSearch {
  constructor(value) {
    this.value = value.toLowerCase();
  }
  [Symbol.search](string) {
    return string.toLowerCase().indexOf(this.value);
  }
}

console.log('foobar'.search(new caseInsensitiveSearch('BaR')));
// expected output: 3</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-symbol.search', 'Symbol.search')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.builtins.Symbol.search")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{jsxref("Symbol.match")}}</li>
 <li>{{jsxref("Symbol.replace")}}</li>
 <li>{{jsxref("Symbol.split")}}</li>
 <li>{{jsxref("RegExp.@@search", "RegExp.prototype[@@search]()")}}</li>
</ul>
